.TH SKWEEL 1 "Apr 19 1994" "Stanford University" "SUIF Compiler"
.SH NAME
skweel \- optimize loop-level parallelism and locality
.SH SYNOPSIS
.B skweel
[
.I options
]
.I infile
.I outfile

.SH DESCRIPTION
The
.I skweel 
program analyzes and transforms the
code to optimize loop-level parallelism and locality.
.PP
The transformations 
.I skweel
performs includes a general class of
loop transformations known as "unimodular transformations". 
These transformations include loop interchange,
loop skewing and loop reversal.  
.I Skweel
can also tile loop nests for cache locality.
.PP
This pass expects two file specifications on the command line, first
for the input file, then for the output file.  
When 
.I scc 
is run with the 
.I \-parallel
or 
.I \-multi 
flags, 
.I skweel 
will be run.  In both cases, 
.I skweel 
is called with the options 
.I -P -T -i.  

.SH OPTIONS:
.TP
.BI \-A " n"
Print out the SUIF code before and/or after transformation.  If the integer
.I n
is set to 1, the SUIF code is printed before transformation. If it is 
set to 2, then the code is printed after transformation.  The
code is printed both before and after transformation if 
.I n 
is set to 3.

.TP
.B \-N
Normalize the loops only; do not transform to improve code.

.TP
.BI \-P " n" 
Parallelism level.  Look for parallelism and annotate the parallel loops in 
the code.  The default is 1.

.TP
.BI \-Q " n"
Process up to 
.I n
functions before quitting.  The default is 100,000.

.TP
.B \-S  
Do not perform scalar privatization.

.TP
.B \-T
Do not tile the code.

.TP
.B \-V 
Turn on verbose mode.  This prints information about the function being 
processed, the dependences found, etc.

.TP
.B \-W
Print statistics about the input program including loop nest shape and
loop nest depth.

.TP
.B \-2 
When tiling a loop nest of depth n, coalesce the tile to generate 2n-1 
loops rather than 2n.

.TP
.BI \-c " n" 
Set the cache size to the integer
.I n
bytes.  This value is used to calculate block sizes when tiling.  The
default is 65536 (64K).

.TP
.BI \-f " g" 
Set the fraction of the cache to fill to the floating-point value
.I g.
This value is used to calculate block sizes when tiling.  The
default is 0.6.

.TP
.B \-i
Interchange loops for register locality.

.TP
.BI \-l " n"
Set the cache line size to the integer
.I n
bytes.  This value is used to calculate block sizes when tiling.

.TP
.B \-p
Print a summary of the for loops in the program.  The summary includes
information about which loops can and cannot be transformed.

.TP
.BI \-y " n"
Do not parallelize loops with less than 
.I n.
iterations.  The default is set to 0, meaning that all parallel loops
found will be marked with "doall" annotations.

.TP
.BI \-z " n"
Do not parallelize loops with less work than the integer
.I n.
The amount of work in a loop is estimated by a function of the loop bounds and
the number of instructions in the loop.  The work estimation function used
by 
.I skweel 
is from  the 
.I useful
library.  The default is set to 0, meaning that all parallel loops found will
be marked with "doall" annotations.

.SH ANNOTATIONS READ
.TP
.PD 0
.TP
.BI privatizable " var"*
This annotation is placed on TREE_FOR nodes by the scalar expansion pass of
.I moo 
and
.I oynk.
Private copies of the var_syms
.I var
can be made for each iteration of the loop nest.  This information is
used to parallelize loops.

.TP
.BI need_finalization " var"*
This annotation is placed on TREE_FOR nodes by the scalar expansion pass of
.I oynk.
Finalization is needed in order for the var_syms
.I var
to privatized. Currently, 
.I skweel
will not privatize any variables that need finalization.

.TP
.B iv_live
This annotation is placed on TREE_FOR nodes by the scalar expansion pass of
.I oynk.
The induction variable for this loop is read after exiting the loop.
If a loop has a live induction variable, 
.I skweel
will not consider transforming the loop.

.TP
.B pure function
This annotation is placed on the proc_sym for FORTRAN intrinsic functions
that are known to have no side-effects.
.I Skweel
will not parallelize loops that contain calls to functions that do not have
"pure function" annotations.

.TP
.BI reduction " type var" 
This annotation is placed on TREE_FOR nodes and instructions by reduction.
A reduction of the commutative operation
.I type
is calculated over the var_sym
.I var.
Currently supported reduction types include sum, product, max and min.

.TP
.PD 0
.B C pragma "doall"
.TP
.B doall
These annotations are generated by the front-end from pragmas in the source
code.  They allow users to explicitly parallelize loops that 
.I skweel
wouldn't otherwise parallelize.  The annotations are placed on mrk
instructions.  When
.I skweel
sees one of these annotations, it puts a "doall" annotation on the closest 
TREE_FOR following the mrk instruction.  The TREE_FOR must be in the
same list as the mrk instruction.  Subsequent passes (e.g. 
.I pgen
) will now treat the loop as parallel.  

.SH ANNOTATIONS WRITTEN
.TP
.PD 0
.B begin_fully_permutable
.TP
.B end_fully_permutable
These annotations are placed on TREE_FOR nodes to mark the boundaries of
fully permutable loop nests.  
If a loop nest is fully permutable then any permutation of the loops within
the nest is legal, and the loop nest can be tiled.

.TP
.B doall
This annotation is placed on TREE_FOR nodes that 
.I skweel 
determines can be legally run in parallel.
The "doall" annotation is read by
.I pgen.

.TP
.BI privatized " vars"+
This annotation is placed on TREE_FOR nodes, and is used in conjunction with
the "doall" annotation.
The var_syms
.I var
must be made private in order for the code to run correctly in parallel.
The "privatized" annotation is read by
.I pgen.

.TP
.BI reduced " type var" 
This annotation is placed on TREE_FOR nodes, and is used in conjunction with
the "doall" annotation.
A reduction of the commutative operation
.I type
must be calculated over the var_sym
.I var
in order for the code to run correctly in parallel.
The "reduced" annotation is read by
.I pgen.

.TP
.B small_bound
This annotation is placed on TREE_FOR nodes.  The loop was not marked 
with a "doall" annotation because the number of iterations in the 
loop was deemed too small (using the parameter specified with the 
.I \-y
flag.

.SH SEE ALSO
fixfortran(1), oynk(1), moo(1), pgen(1), reduction(1), scc(1)

.B
Michael E. Wolf. 
"Improving Locality and Parallelism in Nested Loops",
Ph.D. thesis, Stanford University, Computer
Systems Laboratory, August, 1992.

.B
M. E. Wolf and M. S. Lam.
"A Loop Transformation Theory and An Algorithm to Maximize Parallelism",
.I IEEE Transactions on Parallel and Distributed Systems, 
October, 1991.

.B
M. E. Wolf and M. S. Lam.
"A Data Locality Optimizing Algorithm", 
.I Proceedings of the ACM SIGPLAN'91 Conference on Programming Language Design and Implementation, 
June, 1991.

.SH HISTORY
The original parallelism and locality optimizer for the old SUIF system
was written by Michael Wolf.  Jennifer Anderson translated it to new SUIF,
and added some features.

